﻿Tridion.Type.registerNamespace("Tridion.Web.UI.Core.Controls");

Tridion.Web.UI.Core.Controls.DeckPageWithCatalinaView = function TabWithCatalinaView(element) {
    Tridion.OO.enableInterface(this, "Tridion.Web.UI.Core.Controls.DeckPageWithCatalinaView");
    this.addInterface("Tridion.Controls.DeckPage", [element]);
};

Tridion.Web.UI.Core.Controls.DeckPageWithCatalinaView.createElement = function TabWithCatalinaView$createElement(document) {
    return document.createElement("div");
};

Tridion.Web.UI.Core.Controls.DeckPageWithCatalinaView.prototype._initialize = function TabWithCatalinaView$initialize() {
    this.callBase("Tridion.Controls.DeckPage", "_initialize");

    var element = this.getElement();
    var className = this.getClassNames().join(" ");
    Tridion.Utils.Css.addClass(element, className);

    var onRenderView = this.getDelegate(function onRenderView(catalinaView) {
        this.properties.catalinaView = catalinaView;
        this.addEventHandlersToCatalinaView();
    });

    var p = this.properties;
    SDL.UI.Core.Renderers.ViewRenderer.renderView(this.getCatalinaViewName(), p.element, p.parameters, onRenderView);
};

Tridion.Web.UI.Core.Controls.DeckPageWithCatalinaView.prototype.disposeInterface = Tridion.OO.nonInheritable(function TabWithCatalinaView$disposeInterface() {
    var catalinaView = this.properties.catalinaView;
    if (catalinaView) {
        catalinaView.dispose();
    }
});

Tridion.Web.UI.Core.Controls.DeckPageWithCatalinaView.prototype.getClassNames = function TabWithCatalinaView$getClassNames() {
    return ["DeckPageWithCatalinaView"];
};

Tridion.Web.UI.Core.Controls.DeckPageWithCatalinaView.prototype.getCatalinaViewName = function TabWithCatalinaView$getCatalinaViewName() {
    // return "Some.Class.Name";
};

Tridion.Web.UI.Core.Controls.DeckPageWithCatalinaView.prototype.addEventHandlersToCatalinaView = function TabWithCatalinaView$addEventHandlersToCatalinaView() {
    // sample to access catalinaView
    // var catalinaView = this.properties.catalinaView;
};