﻿Tridion.Type.registerNamespace("SDL.Web.UI.Models.PublicationMappings");

/**
 * Represents a CD Topologies List.
 * @namespace {SDL.Web.UI.Models.PublicationMappings}
 * @constructor
 * @param {String} parentId The parent item's Id.
 * @param {Tridion.ContentManager.ListFilter} filter The List Filter.
 */
SDL.Web.UI.Models.PublicationMappings.ListCdTopologies = function PublicationMappings$ListCdTopologies(parentId, filter)
{
	Tridion.OO.enableInterface(this, "SDL.Web.UI.Models.PublicationMappings.ListCdTopologyTypes");
	this.addInterface("Tridion.ContentManager.List", [parentId, filter]);
};

SDL.Web.UI.Models.PublicationMappings.ListCdTopologies.prototype.executeLoadList = function PublicationMappings$ListCdTopologies$executeLoadList(parentId, filter, success, failure)
{
	sdl.Web.UI.PublicationMappings.Model.Services.TopologyMappingsService.GetTopologies(filter.conditions.topologyTypeId, filter.conditions.webApplicationIds, success, failure);
};