﻿using System;

namespace SDL.Web.UI.PublicationMappings.DataExtenders
{
    public class UnableRemoveMappingsException : Exception
    {
        public UnableRemoveMappingsException()
            :base(Resources.SDL_Web_UI_PublicationMappings_DataExtenders_Strings.UnableToRemoveMappings)
        {}
    }    
	
	public class EnvironmentIsAlreadyConfiguredException : Exception
    {
        public EnvironmentIsAlreadyConfiguredException()
            :base(Resources.SDL_Web_UI_PublicationMappings_DataExtenders_Strings.EnvironmentIsAlreadyConfigured)
        {}
    }
		
	public class MappingsUrlsInUseException : Exception
    {
        public MappingsUrlsInUseException()
            :base(Resources.SDL_Web_UI_PublicationMappings_DataExtenders_Strings.MappingsUrlsAreInUse)
        {}
    }
	
	public class EditDeleteMappingException : Exception
    {
        public EditDeleteMappingException()
            :base(Resources.SDL_Web_UI_PublicationMappings_DataExtenders_Strings.EditDeleteMappingError)
        {}
    }

    public class TopologyManagerUnavailableException : Exception
    {
        public TopologyManagerUnavailableException()
            :base(Resources.SDL_Web_UI_PublicationMappings_DataExtenders_Strings.TopologyManagerUnavailable)
        {}
    }

    public class NoRightsException : Exception
    {
        public NoRightsException(string userId, string publicationId) : 
            base(string.Format(Resources.SDL_Web_UI_PublicationMappings_DataExtenders_Strings.HaveNoRights, userId, publicationId))
        {}
    }
}