﻿using System.IO;
using System.Text;
using System.Xml;
using System.Xml.Linq;

namespace SDL.Web.UI.PublicationMappings.DataExtenders
{
    public static class XmlExtensions
    {
        public static XmlTextReader ToReader(this XmlDocument xmlDocument)
        {
            var reader = new XmlTextReader(new StringReader(xmlDocument.OuterXml));
            reader.MoveToContent();

            return reader;
        }

        public static XmlDocument ToXmlDocument(this XmlTextReader reader)
        {
            var document = new XmlDocument();
            document.Load(reader);
            return document;
        }

        public static XmlElement ToXmlElement(this XElement element)
        {
            var doc = new XmlDocument();
            doc.Load(element.CreateReader());
            return doc.DocumentElement;
        }
    }
}
