﻿Tridion.Type.registerNamespace("SDL.Web.UI.Models.PublicationMappings");

SDL.Web.UI.Models.PublicationMappings.BusinessProcessType = function PublicationMappings$BusinessProcessType(id)
{
	Tridion.OO.enableInterface(this, "SDL.Web.UI.Models.PublicationMappings.BusinessProcessType");
	this.addInterface("Tridion.ContentManager.BusinessProcessType", [id]);
};

SDL.Web.UI.Models.PublicationMappings.BusinessProcessType.prototype.getListItemXml = function PublicationMappings$BusinessProcessType$getListItemXml()
{
	var p = this.properties;
	if (!p.listItemXml)
	{
		p.listItemXml = this.callBase("Tridion.ContentManager.BusinessProcessType", "getListItemXml");
		var listItemXmlDoc = $xml.getNewXmlDocument(p.listItemXml);

		var targetTypesXmlDoc = $xml.getNewXmlDocument(this.getListTopologyTypeTargetTypes().getXml());
		var purposeNodes = $xml.selectNodes(targetTypesXmlDoc, "/tcm:TargetTypes/tcm:TargetType/tcm:Data/tcm:Purpose/text()");
		var purposeNodeArray = Array.prototype.slice.call(purposeNodes);

		purposeNodeArray.forEach(function (purposeNode)
		{
			var purpose = $xml.getInnerText(purposeNode);
			var node = $xml.createElementNS(listItemXmlDoc, $const.Namespaces.pm, "pm:Purpose");
			$dom.setInnerText(node, purpose);

			listItemXmlDoc.documentElement.appendChild(node);
		});

		p.listItemXml = $xml.getOuterXml(listItemXmlDoc);
	}
	
	return p.listItemXml;
};