﻿/// <reference path="../Lists/ListExtendedBusinessProcessTypes.d.ts"/>

declare module SDL.Web.UI.Models.PublicationMappings {
    class Publication {
        constructor(id: string);
        getId(): string;
        getList(filter: any, rowsExclusive: any, columnsExclusive: any, listImplementation?: string): any;
        getDelegate(method: Function, args?: any): Function;
        getXmlDocument(onlyValidCache?: boolean): XMLDocument;
        updateOuterXml(xpath: string, xml: string, context?: any, suppressEvent?: boolean, ns?: any): boolean;
        isLoaded(checkCacheValidity?: boolean): boolean;
        getListBusinessProcessTypes(columnFilter?: any): PublicationMappings.ListExtendedBusinessProcessTypes;
        getBusinessProcessTypeId(): string;
        setBusinessProcessType(value: string, context?: any): void;
        getTopologyMappingsXml(): string;
        setTopologyMappingsXml(mappingsXml: string, context?: any): void;
        areMappingsAccessible(): boolean;
        areMappingsEditable(): boolean;
        hasBptManagementRights(): boolean;
		setChanged(context?: any) : void;
        private _invalidateTopologyMappingProperties(): void;
        private pack() : any;
        private unpack(data: any): void;
    }
}