﻿Tridion.Type.registerNamespace("SDL.Web.UI.Models.PublicationMappings");

/**
 * Represents a Business Process Types List.
 * @namespace {SDL.Web.UI.Models.PublicationMappings}
 * @constructor
 * @param {String} parentId The parent item's Id.
 * @param {Tridion.ContentManager.ListFilter} filter The List Filter.
 */
SDL.Web.UI.Models.PublicationMappings.ListExtendedBusinessProcessTypes = function PublicationMappings$ListExtendedBusinessProcessTypes(parentId, filter)
{
	Tridion.OO.enableInterface(this, "SDL.Web.UI.Models.PublicationMappings.ListExtendedBusinessProcessTypes");
	this.addInterface("Tridion.ContentManager.ListBusinessProcessTypes", [parentId, filter]);
};

SDL.Web.UI.Models.PublicationMappings.ListExtendedBusinessProcessTypes.prototype.getEnvironmentPurposesForBpt = function PublicationMappings$ListExtendedBusinessProcessTypes$getEnvironmentPurposesForBpt(bptId)
{
	var xmlDoc = this.getXmlDocument();
	if (xmlDoc)
	{
		var purposesNodes = $xml.selectNodes(xmlDoc,
			Tridion.Utils.String.format("/tcm:ListBusinessProcessTypes/tcm:Item[@ID='{0}']/pm:Purpose/text()", bptId));

		var result = [];
		for (var i = 0, l = purposesNodes.length; i < l; i++)
		{
			var node = purposesNodes[i];
			result.push($xml.getInnerText(node));
		}

		return result;
	}
};

SDL.Web.UI.Models.PublicationMappings.ListExtendedBusinessProcessTypes.prototype.getTopologyTypeForBpt = function PublicationMappings$ListExtendedBusinessProcessTypes$getTopologyTypeForBpt(bptId)
{
	var xmlDoc = this.getXmlDocument();
	if (xmlDoc)
	{
		var topologyTypeNode = $xml.selectSingleNode(xmlDoc,
			Tridion.Utils.String.format("/tcm:ListBusinessProcessTypes/tcm:Item[@ID='{0}']/@CdTopologyTypeId", bptId));
		if (topologyTypeNode)
		{
			return $xml.getInnerText(topologyTypeNode);
		}
	}
};