﻿using System.ServiceModel;
using System.ServiceModel.Activation;
using System.ServiceModel.Web;
using SDL.Web.UI.PublicationMappings.Model.Services.Implementation;
using SDL.Web.UI.PublicationMappings.Model.Services.Interfaces;
using Tridion.Web.UI.Core.Extensibility;

namespace SDL.Web.UI.PublicationMappings.Model.Services
{
	[ServiceContract(Namespace = "http://SDL/Web/UI/PublicationMappings.Model.Services", Name = "TopologyMappingsService")]
    [DataExtenderBehavior(TreatReturnValueAsXml = false)]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Required)]
	public class TopologyMappingsService : ITopologyMappingsService
    {
        private readonly ITopologyMappingsService _implementation = new TopologyMappings();

        [OperationContract]
        [WebInvoke(Method = "POST",
                    RequestFormat = WebMessageFormat.Json,
                    ResponseFormat = WebMessageFormat.Json)]
        public string GetMappings(string publicationId)
        {
            return _implementation.GetMappings(publicationId);
        }

        [OperationContract]
        [WebInvoke(Method = "POST",
            RequestFormat = WebMessageFormat.Json,
            ResponseFormat = WebMessageFormat.Json)]
        public string GetTopologies(string topologyTypeId, string[] webApplicationIds = null)
        {
            return _implementation.GetTopologies(topologyTypeId, webApplicationIds);
        }

		[OperationContract]
		[WebInvoke(Method = "POST",
			RequestFormat = WebMessageFormat.Json,
			ResponseFormat = WebMessageFormat.Json)]
		public string GetWebApplications(string[] environmentIds, string purpose = null)
		{
			return _implementation.GetWebApplications(environmentIds, purpose);
		}
    }
}