﻿using System.Xml;
using Tridion.Web.UI.Core.Extensibility;

namespace SDl.Web.UI.PublicationMappings.Tests.DataExtenders
{
    public class DataExtenderTestsHelper
    {
        public static XmlTextReader GetReader(string input)
        {
            var reader = new XmlTextReader(new System.IO.StringReader(input));
            reader.MoveToContent();
            return reader;
        }

        public static PipelineContext GetPipelineContext(string commandName, string id = "")
        {
            var context = new PipelineContext();
            context.Parameters.Add("command", commandName);

            if (!string.IsNullOrEmpty(id))
            {
                context.Parameters.Add("id", id);
            }

            return context;
        }

        public static XmlNamespaceManager XmlNamespaceManager
        {
            get
            {
                var xmlNamespaceManager = new XmlNamespaceManager(new NameTable());

                xmlNamespaceManager.AddNamespace(Tridion.Constants.TcmPrefix, Tridion.Constants.TcmNamespace);
                xmlNamespaceManager.AddNamespace(Tridion.Constants.XlinkPrefix, Tridion.Constants.XlinkNamespace);
                xmlNamespaceManager.AddNamespace(SDL.Web.UI.PublicationMappings.Model.Constants.PublicationMappingsPrefix, SDL.Web.UI.PublicationMappings.Model.Constants.PublicationMappingsNamespace.NamespaceName);

                return xmlNamespaceManager;
            }
        }
    }
}